	SUBROUTINE RDASN (INUNIT,USEDMS)
C
C	SUBROUTINE TO SPECPRO
C	READS COMPOUND AND MECHANISM ASSIGNMENT DATA
C
C	INUNIT=UNIT TO READ ASSIGNMENT MODIFICATIONS (ZERO IF UNUSED)
C	USEDMS=TRUE IF DMS DATA TO BE READ IN AND PROCESSED
C
	INTEGER INUNIT
	LOGICAL USEDMS
C
C	SPECIFICATIONS FOR MODEL SPECIES AND COMPOUNDS FOR
C	SPECPRO AND ITS SUBROUTINES
C
	INCLUDE 'SPECSPEC.FOR'
C
C	LOCAL DATA
C
	CHARACTER INLIN*250,INFILE*80,CMPDI*16,NAMEIN*8,BYT2*2,DMSI*8
	REAL MWI,LOSTC
	LOGICAL ERRIND,ABORT,DMSFMT,HASDMS
C
C
C	READ MODEL SPECIES PROPERTIES FROM MechMS.DAT
C
	IF (EDBUIC(1:1).EQ.' ') THEN
		INFILE=MECHID(1:LMECID)//'MS.DAT'
	ELSE
		INFILE=EDBUIC(1:LEDBUC)//MECHID(1:LMECID)//'MS.DAT'
	ENDIF
	OPEN (UNIT=2,FILE=INFILE,STATUS='OLD',ERR=902)	! READONLY
	NROGNM=' '
   30	READ (2,1,END=903) INLIN
    1	FORMAT (A)
	IF (INLIN(1:6).EQ.'INERT=') THEN
		NROGNM=INLIN(7:)
	ENDIF
	IF (INLIN(1:1).NE.'.') GOTO 30
C
	NMS=0
	INROG=0
   31	READ (2,1,END=38) INLIN
	IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 31
	CALL PARSE0 (4,INLIN,80)
	CALL PARSE1 (1,NAMEIN,I,8,INLIN)
	CALL PARSEI (2,NCI,ERRIND,INLIN)
	IF (ERRIND) GOTO 31
	CALL PARSER (3,MWI,ERRIND,INLIN)
	IF (ERRIND) GOTO 31
	CALL PARSE1 (4,BYT2,I,2,INLIN)
	IF (NMS.EQ.MAXMS) THEN
		WRITE (6,*) 'INCRERASE MAXMS IN SPECPRO.FOR'
		CALL EXIT (2)
	ENDIF
	NMS=NMS+1
	MSNAM(NMS)=NAMEIN
	MSNC(NMS)=NCI
	MSMWT(NMS)=MWI
	MSPRM(NMS)=BYT2
	IF (BYT2(1:1).EQ.' ') THEN
		MSLMP(NMS)=0	! Base mechanism species
	ELSE
		MSLMP(NMS)=-1	! Adjust parm species (not in base mech)
	ENDIF
	MSDMS(NMS)=0
	MSLIK(NMS)=' '
	IF (NAMEIN.EQ.NROGNM) INROG=NMS
	GOTO 31
   38	CLOSE (UNIT=2)
	IF (NMS.EQ.0) GOTO 903
C
C	READ COMPOUND MODEL SPECIES ASSIGNMENTS FROM mechASN.DAT
C	(THIS FILE ALSO CONTAINS MWT AND NC DATA FOR COMPOUNDS)
C
	IF (EDBUIC(1:1).EQ.' ') THEN
		INFILE=MECHID(1:LMECID)//'ASN.DAT'
	ELSE
		INFILE=EDBUIC(1:LEDBUC)//MECHID(1:LMECID)//'ASN.DAT'
	ENDIF
	OPEN (UNIT=2,FILE=INFILE,STATUS='OLD',ERR=902)	! READONLY
C
	NSPC=0
	SPCFMT=0
	DMSFMT=.FALSE.
	HASDMS=.FALSE.
	DMSI=' '
	NDMS=0
  40	READ (2,1,END=903) INLIN
	IF (INLIN(1:7).EQ.'FORMAT=') THEN
		READ (INLIN(8:8),'(I1)') SPCFMT
		HASDMS=INLIN(9:9).EQ.'D'
		IF (USEDMS.AND.(SPCFMT.EQ.1.OR.SPCFMT.EQ.2))
     &		 DMSFMT=HASDMS
		GOTO 40
	ELSEIF (INLIN(1:1).NE.'.') THEN
		GOTO 40
	ENDIF
	IF (SPCFMT.EQ.0) THEN
		WRITE (6,*) 'Format not defined in ',INFILE
		CALL EXIT (2)
	ELSEIF (SPCFMT.EQ.1.OR.SPCFMT.EQ.2) THEN
  41		READ (2,1,END=99) INLIN
		IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 41
		IF (SPCFMT.EQ.1) THEN
			IF (HASDMS) THEN
				CALL PARSE0 (6,INLIN,80)
				IF (DMSFMT) CALL PARSE1 
     &				 (6,DMSI,I,8,INLIN)
			ELSE
				CALL PARSE0 (5,INLIN,80)
			ENDIF
			WTI=1.0
		ELSE
			IF (HASDMS) THEN
				CALL PARSE0 (7,INLIN,80)
				IF (DMSFMT) CALL PARSE1 
     &				 (7,DMSI,I,8,INLIN)
			ELSE
				CALL PARSE0 (6,INLIN,80)
			ENDIF
			CALL PARSER (6,WTI,ERRIND,INLIN)
			IF (ERRIND) GOTO 41
		ENDIF
		CALL PARSE1 (1,CMPDI,I,16,INLIN)
		CALL PARSER (2,MWI,ERRIND,INLIN)
		IF (ERRIND) GOTO 41
		CALL PARSEI (3,NCI,ERRIND,INLIN)
		IF (ERRIND) GOTO 41
		CALL PARSE1 (4,BYT2,I,1,INLIN)
		CALL PARSE1 (5,NAMEIN,I,8,INLIN)
C
		IF (NSPC.EQ.MAXSPC) THEN
			WRITE (6,*) 'INCREASE MAXSPC IN SPECSPEC.FOR'
			CALL EXIT (2)
		ENDIF
		NSPC=NSPC+1
		SPCNAM(NSPC)=CMPDI
		SPCNC(NSPC)=NCI
		SPCMW(NSPC)=MWI
		SPCDMS(NSPC)=0
		SPCXMT(NSPC)=BYT2(1:1).NE.'1'
C
		IF (NAMEIN.EQ.'NOASN   ') THEN
			SPCASN(NSPC)=.FALSE.
			SPCVOL(NSPC)=.TRUE.
		ELSEIF (NAMEIN.EQ.'NONVOL  ') THEN
			SPCASN(NSPC)=.TRUE.
			SPCVOL(NSPC)=.FALSE.
		ELSE
			DO 411 I=1,NMS
				IF (NAMEIN.EQ.MSNAM(I)) THEN
					SPCMS(NSPC)=I
					SPCMSW(NSPC)=WTI
					SPCASN(NSPC)=.TRUE.
					SPCVOL(NSPC)=.TRUE.
					GOTO 4110
				ENDIF
  411			CONTINUE
C
C			UNKNOWN MODSPE ARE TREATED AS UNASN
			SPCASN(NSPC)=.FALSE.
			SPCVOL(NSPC)=.TRUE.
		ENDIF
C
C		PROCESS DMS IF APPLICABLE
C
 4110		IF (DMSFMT.AND.SPCASN(NSPC).AND.SPCVOL(NSPC).AND.
     &		 DMSI(1:1).NE.' '.AND.DMSI.NE.'NOASN     ') THEN
			IF (NDMS.GT.0) THEN
				DO 4111 I=1,NDMS
				IF (DMSNAM(I).EQ.DMSI) THEN
					SPCDMS(NSPC)=I
					GOTO 41
				ENDIF
 4111				CONTINUE
			ENDIF
			IF (NDMS.EQ.MAXDMS) THEN
				WRITE (6,*) 'INCREASE MAXDMS IN '
     &				 //'SPECSPEC'
				CALL EXIT (2)
			ENDIF
			NDMS=NDMS+1
			DMSNAM(NDMS)=DMSI
			SPCDMS(NSPC)=NDMS
		ENDIF
		GOTO 41
C
	ELSEIF (SPCFMT.EQ.3) THEN
C
C		FOR FORMAT=3 IT IS EXPECTED THAT THE MODEL SPECIES
C		ARE EXACTLY THE SAME IN NUMBER AND ORDER IN 
C		MechASN.DAT and MechMS.DAT, OR ABORTS.
C
		IF (NMS.GT.MAXTP3) THEN
			WRITE (6,*) 'INCREASE MAXTP3 IN SPECSPEC.FOR'
			CALL EXIT (2)
		ENDIF
		READ (2,*,END=903)
C
  44		READ (2,1,END=99) INLIN
		IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 44
		IF (NSPC.EQ.MAXSPC) THEN
			WRITE (6,*) 'INCREASE MAXSPC IN SPECSPEC.FOR'
			CALL EXIT (2)
		ENDIF
		NSPC=NSPC+1
		READ (INLIN,4401,ERR=4408) SPCNAM(NSPC),SPCMW(NSPC),
     &		 SPCNC(NSPC),NAMEIN(1:1),INDVOC,
     &		 (SPCMSF(NSPC,I),I=1,NMS)
 4401		FORMAT(A16,F8.3,I3,2X,A1,1X,I3,1X,20F6.2)
		IF (NAMEIN(1:1).EQ.'N') THEN
			SPCASN(NSPC)=.TRUE.
			SPCVOL(NSPC)=.FALSE.
		ELSEIF (NAMEIN(1:1).EQ.'U') THEN
			SPCASN(NSPC)=.FALSE.
			SPCVOL(NSPC)=.TRUE.
		ELSE
			SPCASN(NSPC)=.TRUE.
			SPCVOL(NSPC)=.TRUE.
		ENDIF
		SPCXMT(NSPC)=INDVOC.EQ.0
		GOTO 44
C
 4408		WRITE (6,*) 'Error reading mechASN.DAT file'
		WRITE (6,*) 'BAD RECORD='//INLIN(1:LNBLNK(INLIN))
		CALL EXIT (2)
C
	ELSE
		WRITE (6,*) 'Unsupported format number (',
     &		 SPCFMT,' IN ',INFILE
		CALL EXIT (2)
	ENDIF
C
  99	CLOSE (UNIT=2)
C
C	RE-READ INPUT FILE TO PROCESS MECHANISM OVERRIDE INPUT, IF ANY
C	ALL OTHER INPUT IS IGNORED.
C
C	PARAMETER CODES USED FOR NEW SPECIES:
C		* = ADJUSTABLE PARAMETER INPUT
C		(NO CODE MEANS DON'T DERIVE ADJ. PARMS, RXNS MUST BE
C		IN A FILE)
C
	IF (INUNIT.EQ.0) RETURN
C
	REWIND (UNIT=INUNIT)
	ABORT=.FALSE.
 450	READ (INUNIT,1,END=459) INLIN
	IF (INLIN(1:9).EQ.'EXPLICIT=') THEN
		CALL PARSE0(4,INLIN(10:),70)
		CALL PARSE1 (2,NAMEIN,I,8,INLIN(10:))
		IF (NAMEIN(1:1).EQ.' ') GOTO 458
		CALL PARSE1 (1,CMPDI,I,16,INLIN(10:))
		IF (CMPDI(1:1).EQ.' ') GOTO 458
		CALL PARSE1 (3,BYT2,I,2,INLIN(10:))
		DO 451 ISPC=1,NSPC
			IF (CMPDI.EQ.SPCNAM(ISPC)) THEN
				IF (NMS.EQ.MAXMS) THEN
					WRITE (6,*)
     &					 'INCREASE MAXMS IN SPECPRO'
					CALL EXIT (2)
				ELSEIF (SPCFMT.EQ.3.AND.NMS.EQ.MAXTP3)
     &				 THEN
					WRITE (6,*)
     &					 'INCREASE MAXTP3 IN SPECPRO'
					CALL EXIT (2)
				ENDIF
				NMS=NMS+1
				MSNAM(NMS)=NAMEIN
				MSMWT(NMS)=SPCMW(ISPC)
				MSNC(NMS)=SPCNC(ISPC)
				MSPRM(NMS)=BYT2
				CALL PARSE1 (4,MSLIK(NMS),I,8,
     &				 INLIN(10:))
				IF (SPCDMS(ISPC).GT.0) THEN
					MSDMS(NMS)=SPCDMS(ISPC)
					MSLMP(NMS)=-1
				ELSE
					MSDMS(NMS)=0
					MSLMP(NMS)=-2
				ENDIF
				SPCASN(ISPC)=.TRUE.
				SPCVOL(ISPC)=.TRUE.
				IF (SPCFMT.EQ.1.OR.SPCFMT.EQ.2) THEN
					SPCMS(ISPC)=NMS
					SPCMSW(ISPC)=1.0
				ELSEIF (SPCFMT.EQ.3) THEN
					DO 4511 I=1,NSPC
 4511					SPCMSF(I,NMS)=0.0
					DO 4512 I=1,NMS-1
 4512					SPCMSF(ISPC,I)=0.0
					SPCMSF(ISPC,NMS)=1.0
				ENDIF
				GOTO 450
			ENDIF
  451		CONTINUE
		GOTO 457
C
	ELSEIF (INLIN(1:7).EQ.'MODSPE=') THEN
		CALL PARSE0 (5,INLIN(8:),70)
		CALL PARSE1 (1,NAMEIN,I,8,INLIN(8:))
		IF (NAMEIN(1:1).EQ.' ') GOTO 458
		CALL PARSER (2,MWI,ERRIND,INLIN(8:))
		IF (ERRIND.OR.MWI.LE.0.0) GOTO 458
		CALL PARSEI (3,NCI,ERRIND,INLIN(8:))
		IF (ERRIND.OR.NCI.LE.0.0) GOTO 458
		CALL PARSE1 (4,BYT2,I,2,INLIN(8:))
C
C		IF THIS IS PREVIOUSLY INPUT (E.G., BASE) MODEL SPECIES,
C		THEN ONLY THE MWT AND CARBON NO'S CAN BE CHANGED USING
C		A MODSPE COMMAND, SINCE IT IS EXPECTED ITS REACTIONS
C		ARE ALREADY IN THE BASE MECHANSIM FILE.
		DO 4521 I=1,NMS
			IF (NAMEIN.EQ.MSNAM(I)) THEN
				MSMWT(I)=MWI
				MSNC(IMS)=NCI
				GOTO 450
			ENDIF
 4521		CONTINUE
C
 		IF (NMS.EQ.MAXMS) THEN
			WRITE (6,*) 'INCREASE MAXMS IN SPECPRO'
			CALL EXIT (2)
		ELSEIF (SPCFMT.EQ.3.AND.NMS.EQ.MAXTP3) THEN
			WRITE (6,*) 'INCREASE MAXTP3 IN SPECPRO'
			CALL EXIT (2)
		ENDIF
		NMS=NMS+1
		MSNAM(NMS)=NAMEIN
		MSDMS(NMS)=0
		MSPRM(NMS)=BYT2
		IF (SPCFMT.EQ.3) THEN
			DO 4523 I=1,NSPC
 4523			SPCMSF(I,NMS)=0.0
		ENDIF
		IMS=NMS
 4522		MSMWT(IMS)=MWI
		MSNC(IMS)=NCI
		IF (BYT2(1:1).EQ.' ') THEN
			MSLMP(IMS)=-2	! MUST READ RXN FROM FILE
		ELSE
			MSLMP(IMS)=-1	! DERIVE RXN FROM PARM, IF ABLE
		ENDIF
		CALL PARSE1 (5,MSLIK(IMS),I,8,INLIN(8:))
C
	ELSEIF (INLIN(1:7).EQ.'MODREP=') THEN
		IF (SPCFMT.EQ.3) THEN
			I=13
		ELSE
			I=3
		ENDIF
		CALL PARSE0 (I,INLIN(8:),73)
		CALL PARSE1 (2,NAMEIN,I,8,INLIN(8:))
		IF (NAMEIN(1:1).EQ.' ') GOTO 458
		CALL PARSE1 (1,CMPDI,I,16,INLIN(8:))
		IF (CMPDI(1:1).EQ.' ') GOTO 458
		CALL PARSR2 (3,WTI,1.0,ERRIND,INLIN(8:))
		IF (ERRIND) GOTO 458
		DO 453 ISPC=1,NSPC
			IF (CMPDI.EQ.SPCNAM(ISPC)) THEN
				SPCASN(ISPC)=.TRUE.
				SPCVOL(ISPC)=.TRUE.
				IF (SPCFMT.EQ.1.OR.SPCFMT.EQ.2) THEN
					DO 4531 I=1,NMS
					IF (NAMEIN.EQ.MSNAM(I)) THEN
						SPCMS(ISPC)=I
						SPCMSW(ISPC)=WTI
						GOTO 450
					ENDIF
 4531					CONTINUE
					GOTO 4571
				ELSEIF (SPCFMT.EQ.3) THEN
					DO 4533 I=1,NMS
 4533					SPCMSF(ISPC,I)=0.0
					LOSTC=FLOAT(SPCNC(ISPC))
					K=2
C
 4535					DO 4536 I=1,NMS
					IF (NAMEIN.EQ.MSNAM(I)) THEN
						IF (I.NE.INROG) 
     &						 SPCMSF(ISPC,I)=WTI
						LOSTC=LOSTC-(WTI*
     &						 FLOAT(MSNC(I)))
						GOTO 4537
					ENDIF
 4536					CONTINUE
					GOTO 4571
 4537					K=K+2
					IF (K.GT.12) GOTO 4538
					CALL PARSE1 
     &					 (K,NAMEIN,I,8,INLIN(8:))
					IF (NAMEIN(1:1).EQ.' ') 
     &					 GOTO 4538
					CALL PARSER (K+1,WTI,ERRIND,
     &					 INLIN(8:))
					IF (ERRIND) GOTO 458
					GOTO 4535
C
C					ADD INERT TO BALANCE C
 4538					IF (LOSTC.NE.0.0.AND.
     &					 INROG.NE.0) SPCMSF(ISPC,
     &					 INROG)=LOSTC/FLOAT(
     &					 MSNC(INROG))
				ENDIF
				GOTO 450
			ENDIF
  453		CONTINUE
		GOTO 457
C
	ENDIF
	GOTO 450
C
 4571	WRITE (6,*) 'Model species not found: '//NAMEIN
	GOTO 458
  457	WRITE (6,*) 'Compound not found: ',CMPDI
  458	WRITE (6,*) 'Error processing '//INLIN(1:LNBLNK(INLIN))
	ABORT=.TRUE.
	GOTO 450
C
  459	IF (ABORT) CALL EXIT (2)
	RETURN
C
C	ERRORS
C
 902	WRITE (6,*) 'Error opening assignment file = '//INFILE
	GOTO 999
 903	WRITE (6,*) 'No data in assignment file = '//INFILE
 999	CALL EXIT (2)
	END
