	SUBROUTINE RDPRO(INFILE,OUTU,INU)
C
C	SUBROUTINE TO READ PROFILE DATA FROM SPECIFIED .EMC FILE
C	AND MAKE ASSIGNMENTS OF MODEL SPECIES.
C	RESULTS GO TO PROFILE DATR COMMONS (MSMAS=0 MEANS FAILURE)
C
C	ASSUMES UNIT=3 OPEN FOR LOG AND ERROR MESSAGES
C
	CHARACTER INFILE*80	! FULL PATH OF .EMC FILE FOR PROFILE\
	INTEGER OUTU		! OUTPUT UNIT (0 IF NOT OPENED)
	INTEGER INU		! IF NONZERO, TAKES INPUT FROM THIS UNIT,
c				  (ASSUMED TO BE IN ProfProE format), and
C				  INFILE is ignored.  SET TO 0 IF EOF
C
C	SPECIFICATIONS FOR MODEL SPECIES AND COMPOUNDS FOR
C	SPECPRO AND ITS SUBROUTINES
C
	INCLUDE 'SPECSPEC.FOR'
C
C	PROFILE DATA
C
	REAL TOTMAS,UNKMAS,UNAMAS,UNAMOL,UNRMAS,NOVMAS,TOTNC,VOLMAS,
     &	 TOTMOL,MSMAS(MAXMS),MSMOL(MAXMS),XMTMAS
	COMMON /PRODAT/ TOTMAS,TOTMOL,UNKMAS,UNAMAS,UNAMOL,UNAC,
     &	 UNRMAS,NOVMAS,TOTNC,VOLMAS,MSMAS,MSMOL,XMTMAS
C
C
C	LOCAL VARIABLES
C
	CHARACTER INLIN*250,CMPDI*16
	REAL MOLI
	LOGICAL ERRIND
C
	TOTMAS=0.0
	TOTMOL=0.0
	UNKMAS=0.0	! MASS NOT ASSIGNED A COMPOUND
	UNAMAS=0.0	! COMPOUNDS NOT ASSIGNED TO MODSPE
	UNAMOL=0.0
	UNAC=0.0
	UNRMAS=0.0	! UNREACTIVE MASS NOT ASSIGNED TO A COMPOUND
	NOVMAS=0.0	! NON-VOLATILE MASS (TREAT AS UNREACTIVE)
	TOTNC=0.0
	VOLMAS=0.0	! THIS IS MASS ASSIGNED TO MODEL SPECIES
	XMTMAS=0.0	! THIS IS EPA-EXEMPT VOC MASS

	DO 1031 I=1,NMS
	MSMAS(I)=0.0
 1031	MSMOL(I)=0.0
C
	IF (INU.EQ.0) THEN
		INUI=4
		OPEN (UNIT=4,FILE=INFILE,STATUS='OLD',ERR=102)	! READONLY
c
  103		READ (4,1,END=104) INLIN(1:1)
    1		FORMAT (A)
		IF (INLIN(1:1).NE.'.') GOTO 103  
	ELSE
		INUI=INU
	ENDIF
C
  110	READ (INUI,1,END=190) INLIN
	IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 110
	IF (INLIN(1:2).EQ.'..') THEN
		IF (INU.EQ.0) THEN
			GOTO 190
		ELSE
			GOTO 1901
		ENDIF
	ENDIF
	CALL PARSE0 (2,INLIN,80)
	CALL PARSE1 (1,CMPDI,I,16,INLIN)
	CALL PARSER (2,WTI,ERRIND,INLIN)
	IF (ERRIND) GOTO 111
	TOTMAS=TOTMAS+WTI
C
	IF (CMPDI(1:6).EQ.'NOASN ') THEN
		UNKMAS=UNKMAS+WTI
		GOTO 110
	ELSEIF (CMPDI(1:7).EQ.'NONVOL ') THEN
		NOVMAS=NOVMAS+WTI
		GOTO 110
	ELSEIF (CMPDI(1:6).EQ.'INERT ') THEN
		UNRMAS=UNRMAS+WTI
		GOTO 110
	ENDIF
C
C	FIND WHICH COMPOUND THIS IS
C
	DO 112 ISPC=1,NSPC
		IF (CMPDI.EQ.SPCNAM(ISPC)) THEN
		    IF (SPCVOL(ISPC)) THEN
			MOLI=WTI/SPCMW(ISPC)
			TOTMOL=TOTMOL+MOLI
			CMOLI=MOLI*FLOAT(SPCNC(ISPC))
			TOTNC=TOTNC+CMOLI
			IF (SPCXMT(ISPC)) XMTMAS=XMTMAS+WTI
			IF (SPCASN(ISPC)) THEN
				IF (SPCFMT.LT.3) THEN
					WTF=SPCMSW(ISPC)
					IMS=SPCMS(ISPC)
					MSMAS(IMS)=MSMAS(IMS)
     &					 +(WTF*WTI)
					MSMOL(IMS)=MSMOL(IMS)
     &					 +(WTF*MOLI)
					IF (WTF.NE.1.0) THEN
					    IF (INROG.EQ.0) THEN
						UNRMAS=
     &						 UNRMAS+(WTI*(1.0-WTF))
					    ELSE
						MSMAS(INROG)=
     &						 MSMAS(INROG)+(WTI*(
     &						 1.0-WTF))
						MSMOL(INROG)=
     &						 MSMOL(INROG)+(MOLI*(
     &						 1.0-WTF))
					    ENDIF
					ENDIF
				ELSE
C					FOR FORMAT=3 MECHANISMS (E.G., 
C					CB4) USE CARBON FRACTIONS TO
C					DISTRIBUTE MASS AMONG MODEL
C					SPECIES.
C
					DO 1121 I=1,NMS
					  SFI=SPCMSF(ISPC,I)
					  MSMOL(I)=MSMOL(I)+MOLI*SFI
					  MSMAS(I)=MSMAS(I)+(WTI*SFI*
     &					   FLOAT(MSNC(I))/
     &					   FLOAT(SPCNC(ISPC)))
 1121					CONTINUE
				ENDIF
				VOLMAS=VOLMAS+WTI
			ELSE
				UNAMAS=UNAMAS+WTI
				UNAMOL=UNAMOL+MOLI
				UNAC=UNAC+CMOLI
			ENDIF
		    ELSE
			IF (XINFO) WRITE (10,8801) 'NONVOL',
     &			 INFILE(1:LNBLNK(INFILE)),
     &			 SPCNAM(ISPC)(1:LNBLNK(SPCNAM(ISPC))),WTI
 8801			FORMAT (A,',',A,',',A,',',1PE12.3)
			NOVMAS=NOVMAS+WTI
		    ENDIF
		    GOTO 110
		ENDIF
  112	CONTINUE
	CLOSE (UNIT=4)
	WRITE (6,*) CMPDI//' not found in '//INFILE(1:LNBLNK(INFILE))
	IF (OUTU.NE.0) WRITE (OUTU,*) ',,,**Unknown Cmpd,'
     &	 //INFILE(1:LNBLNK(INFILE))//','//CMPDI
	TOTMAS=0.0
	RETURN
C
C	EOF ON EMC FILE.
C
  190	IF (INU.EQ.0) THEN
		CLOSE (UNIT=4)
	ELSE
		CLOSE (UNIT=INU)
		INU=0
	ENDIF
 1901	IF (TOTMAS.EQ.0.0) GOTO 104
C
C	IF THERE IS AN INERT MODEL SPECIES THEN ADD UNSPECIATED INERT
C	MASS TO IT, USING THE MODEL SPECIES MWT TO GET INERT MOLES.  IF
C	NOT, THEN DON'T PROCESS IT.
C
	IF (UNRMAS.NE.0.0) THEN
		IF (INROG.NE.0) THEN
			MSMAS(INROG)=MSMAS(INROG)+UNRMAS
			UNRMOL=UNRMAS/MSMWT(INROG)
			MSMOL(INROG)=MSMOL(INROG)+UNRMOL
			TOTMOL=TOTMOL+UNRMOL
			TOTNC=TOTNC+(UNRMOL*FLOAT(MSNC(INROG)))
			VOLMAS=VOLMAS+UNRMAS
C		ELSE
C			NO WAY TO PROCESS INERTS.  NOT ADDED TO VOC MASS
		ENDIF
	ENDIF
C
C	SUCCESSFUL CONCLUSION
C
	RETURN
C
C	ERRORS READING EMC FILE
C
  102	WRITE (6,*) 'No EMC file: '//INFILE(1:LNBLNK(INFILE))
	IF (OUTU.NE.0) WRITE (OUTU,*) ',,,**No EMC,'//
     &	 INFILE(1:LNBLNK(INFILE))
	RETURN
C
  104	WRITE (6,*) 'No data in file: '//INFILE(1:LNBLNK(INFILE))
	IF (OUTU.NE.0) WRITE (OUTU,*) ',,,**Empty,'//
     &	 INFILE(1:LNBLNK(INFILE))
	RETURN
C
  111	IF (INU.EQ.0) CLOSE (UNIT=4)
	WRITE (6,*) 'Error reading data in file: '
     &	 //INFILE(1:LNBLNK(INFILE))
	WRITE (6,*) 'Bad line: '//INLIN(1:LNBLNK(INLIN))
	IF (OUTU.NE.0) WRITE (OUTU,*) ',,,**Bad line in file,'//
     &	 INFILE(1:LNBLNK(INFILE))//','//INLIN(1:LNBLNK(INLIN))
	IF (INU.NE.0) CALL EXIT(1)
	TOTMAS=0.0
	RETURN
	END
