	SUBROUTINE RXNOUT (IUNIT,INDRXN,IMS,ILMP)
C
C	MECHPRO SUBROUTINE TO OUTPUT REACTION IN FORMAT INDICATED BY
C	INDRXN FOR MODEL SPECIES IMS AND LUMPED GROUP ILMP
C
C	** NOTE ** THIS VERSION EXPECTS ALL PARMS TO BE OF THE FORM
C	<RXTYPE(1:2)><PRODPRM(3:4)>, AND DOESN'T CORRECTLY PROCESS 
C	6-DIGIT "CHILD" PARAMETERS OF ADJUSTED PRODUCT MECHANISMS.
C
	INTEGER INDRXN,IMS,ILMP
C
	INCLUDE 'DMSSPC.FOR'
C
	CHARACTER RXTYP*2,RXCHR*8,MSI*8,PHKOD*2,PHFTYP*8,OUTLIN*80
	CHARACTER KPCHR*24,PRDKOD*2,PRDNAM*8,CHPRD*16,CHFAC*8,EASTR*6,
     &	 BSTR*6,QYCHR*8,RXCHR2*4
	LOGICAL ISPHOT,PRM2DO(MAXPRM)
C
C
	MSI=MSNAM(IMS)
	LMSI=LNBLNK(MSI)
C
	IF (NPRM.EQ.0.OR.(.NOT.PRMDFD(ILMP))) THEN
		WRITE (IUNIT,1) '! Reactions parameters undefined for '
     &		 //MSI(1:LMSI)
		RETURN
	ENDIF
	IF (INDRXN.LE.0.OR.INDRXN.GT.2) THEN
		WRITE (IUNIT,1) '! Unsupported INDRXN for '
     &		 //MSI(1:LMSI)
		RETURN
	ENDIF
    1	FORMAT (A)
C
	DO 2 I=1,NPRM
    2	PRM2DO(I)=LMPPRM(ILMP,I).NE.0.0
C
C	LOOP BACK FOR NEXT TYPE OF REACTION TO PROCESS
C
   10	DO 11 I=1,NPRM
	IF (PRM2DO(I)) THEN
		IPRM1=I
		GOTO 1000
	ENDIF
   11	CONTINUE
C
C	CONTROL REACHES HERE IF ALL PARMS HAVE BEEN PROCESSED. EXIT
C
	RETURN
C
 1000	RXTYP=PARMID(IPRM1)(1:2)
C
C	PROCESS RATE CONSTANT.
C	*1 *2 *3 EXPECTED TO BE FIRST 3 PARMS IF A THERMAL RXN
C	PHOT TYPE IS EXPECTED TO BE 1ST PARM IF PHOT RXN.
C	'QY' MAY BE 2ND
C	OTHERWISE, RATE CONSTANT INFO IS MISSING AND GIVEN K=1.
C
	IF (PARMID(I)(3:4).EQ.'*1') THEN
		CALL GETXAR (AFAC,EA,BFAC,LMPPRM(ILMP,IPRM1),
     &		LMPPRM(ILMP,IPRM1+1),LMPPRM(ILMP,IPRM1+2))
		PRM2DO(IPRM1)=.FALSE.
		PRM2DO(IPRM1+1)=.FALSE.
		PRM2DO(IPRM1+2)=.FALSE.
		IPRM1=IPRM1+3
		ISPHOT=.FALSE.
	ELSEIF (RXTYP.EQ.'HV') THEN
		ISPHOT=.TRUE.
		PHKOD=PARMID(IPRM1)(3:4)
		IF (NHV.EQ.0) GOTO 1002
		DO 1001 IHV=1,NHV
		IF (HVPRM(IHV).EQ.PHKOD) THEN
			PHFTYP=HVPHF(IHV)
			GOTO 1003
		ENDIF
 1001		CONTINUE
 1002		PHFTYP='PHOT_'//PHKOD
 1003		CONTINUE
		AFAC=LMPPRM(ILMP,IPRM1)
		IF (PARMID(IPRM1+1)(3:4).EQ.'QY') THEN
			AFAC=AFAC*LMPPRM(ILMP,IPRM1+1)
			PRM2DO(IPRM1)=.FALSE.
			PRM2DO(IPRM1+1)=.FALSE.
			IPRM1=IPRM1+2
		ELSE
			PRM2DO(IPRM1)=.FALSE.
			IPRM1=IPRM1+1
		ENDIF
		ISPHOT=.TRUE.
	ELSE
		WRITE (IUNIT,1) '! ** WARNING: No kinetic parameters '
     &		 //'given for '//RXTYP//' reaction of '//MSI
		AFAC=0.0
	ENDIF
C
C	BYPASS PROCESSING K=0 REACTIONS
C
	IF (AFAC.EQ.0.0) THEN
		DO 1005 IPRM=IPRM1,NPRM
		IF (PARMID(IPRM)(1:2).EQ.RXTYP) PRM2DO(IPRM)=.FALSE.
 1005		CONTINUE
		GOTO 10
	ENDIF
C
C	CREATE REACTANT CODES AND KINETIC PARAMETER STRING
C
	KPCHR=' '
	IF (ISPHOT) THEN
C@
C@	WRITE (IUNIT,'(''PF='',A,'' QY='',1PE8.2)') PHFTYP,AFAC
C@@
		RXCHR='HV'
		LRXCHR=2
		IF (AFAC.NE.1.0) THEN
			WRITE (QYCHR,'(1PE8.2)') AFAC
			IF (QYCHR.EQ.'1.00E+00') THEN
				AFAC=1.0
			ELSEIF (QYCHR(7:7).NE.'0') THEN
				WRITE (QYCHR,'(1PE7.1)') AFAC
					I2=7
			ELSE
				QYCHR(7:7)=QYCHR(8:8)
				IF (QYCHR(5:7).EQ.'E+0') THEN
					I2=4
				ELSE
					I2=7
				ENDIF
				IF (QYCHR(4:4).EQ.'0') THEN
					QYCHR(4:)=QYCHR(5:)
					I2=I2-1
				ENDIF
			ENDIF
		ENDIF
		IF (INDRXN.EQ.1) THEN
			IF (AFAC.EQ.1.0) THEN
				KPCHR='PF='//PHFTYP
			ELSE
				WRITE (KPCHR,
     &				 '(''PF='',A8,1X,''QY='',A)')
     &				 PHFTYP,QYCHR(1:I2)
			ENDIF
		ELSE
			WRITE (KPCHR,'(''# '',A,''/<'',A,''>'')')
     &			 QYCHR(1:I2),PHFTYP(1:LNBLNK(PHFTYP))
		ENDIF
	ELSE
C@
C@	WRITE (IUNIT,'(1PE10.3,0P2F9.2)') AFAC,EA,BFAC
C@@
		DO 1011 I=1,NPRD
		IF (PRDPRM(I).EQ.RXTYP) THEN
			RXCHR=PRDSPE(I)
			GOTO 1012
		ENDIF
 1011		CONTINUE
		RXCHR=RXTYP
 1012		LRXCHR=LNBLNK(RXCHR)
C
		IF (INDRXN.EQ.1) THEN
			IF (BFAC.EQ.0.0) THEN
				IF (EA.EQ.0.0) THEN
					WRITE (KPCHR,1018) AFAC
				ELSE
					WRITE (KPCHR,1018) AFAC,EA
				ENDIF
			ELSE
				WRITE (KPCHR,1018) AFAC,EA,BFAC
			ENDIF
 1018			FORMAT (1PE8.2,0PF8.3,F6.2)
		ELSE
			IF (EA.NE.0.0) THEN
				WRITE (EASTR,'(F6.0)') 503.22*EA
				IF (EASTR.EQ.'    0.') THEN
					EA=0.0
				ELSEIF (EASTR(3:3).EQ.' ') THEN
					I1=4
				ELSEIF (EASTR(2:2).EQ.' ') THEN
					I1=3
				ELSEIF (EASTR(1:1).EQ.' ') THEN
					I1=2
				ELSE
					I1=1
				ENDIF
			ENDIF
			IF (BFAC.NE.0.0) THEN
				WRITE (BSTR,'(F6.2)') BFAC
				IF (BSTR.EQ.'  0.00') THEN
					BFAC=0.0
				ELSE
					IF (BSTR(6:6).EQ.'0') THEN
						I2B=5
					ELSE
						I2B=6
					ENDIF
					IF (BSTR(2:2).EQ.' ') THEN
						I2A=3
					ELSEIF (BSTR(1:1).EQ.' ') THEN
						I2A=2
					ELSE
						I2A=1
					ENDIF
				ENDIF
			ENDIF
			IF (BFAC.EQ.0.0) THEN
				IF (EA.EQ.0.0) THEN
					WRITE (KPCHR,'(''#'',1PE10.3)')
     &					 AFAC
				ELSE
					WRITE (KPCHR,
     &					'(''#'',1PE10.3,''@'',A)')
     &					 AFAC,EASTR(I1:5)
				ENDIF
			ELSEIF (EA.EQ.0.0) THEN
				WRITE 
     &				 (KPCHR,'(''# '',1PE9.3,''^'',A)')
     &				 AFAC,BSTR(I2A:I2B)
			ELSE
				WRITE (KPCHR,
     &				 '(''#'',1PE9.3,''^'',A,''@'',A)') 
     &				 AFAC,BSTR(I2A:I2B),EASTR(I1:5)
			ENDIF
		ENDIF
	ENDIF
C
C	INITILAIZE OUTPUT STRING.
C	(IF MODSPE PREFIX CHARS NOT DEFINED, MAKE ONE FROM SPEC #
C
	IF (MSPRM(IMS)(1:1).EQ.' ') WRITE (MSPRM(IMS),'(Z2)') IMS
	IF (RXCHR(1:LRXCHR).EQ.'OP') THEN
		RXCHR2='O3P'
		LX2=3
	ELSEIF (RXCHR(1:LRXCHR).EQ.'N3') THEN
		RXCHR2='NO3'
		LX2=3
	ELSE
		RXCHR2=RXCHR
		LX2=2
	ENDIF
	IF (INDRXN.EQ.1) THEN
		WRITE (OUTLIN,
     &		 '(A2,A2,'') '',A23,'';'',A,'' + '',A,'' ='')') 
     &		 MSPRM(IMS),RXTYP,KPCHR,MSI(1:LMSI),RXCHR2(1:LX2)
		ICHR=35+LMSI+LX2
	ELSE
		WRITE (OUTLIN,
     &		 '(''<'',A2,A2,''> '',A,'' + '',A,'' ='')') MSPRM(IMS),
     &		 RXTYP,MSI(1:LMSI),RXCHR2(1:LX2)
		ICHR=12+LMSI+LX2
	ENDIF
C
C	INITIALIZE CARBON COUNT AND PROCESS PRODUCT FORMATION
C
	RXNNC=FLOAT(MSNC(IMS))
C
C	BEGIN LOOP OVER PRODUCTS
C
	DO 1100 IPRM=IPRM1,NPRM
	IF ((.NOT.PRM2DO(IPRM)).OR.(PARMID(IPRM)(1:2).NE.RXTYP)) GOTO
     &	 1100
	PRM2DO(IPRM)=.FALSE.
C
	PRDKOD=PARMID(IPRM)(3:4)
	IF (PRDKOD.EQ.'XC') GOTO 1100
C
C	GET PRODUCT NAME.  IGNORE PARM IF '-' OR NOT FOUND
C	ALSO, ASSUME 3-DIGIT PRECISION, SO PRODUCT NOT COUNTED IF
C	OUTPUT AS 0.000
C
	DO 1101 I=1,NPRD
		IF (PRDKOD.EQ.PRDPRM(I)) THEN
			PRDNAM=PRDSPE(I)
			IF (PRDNAM(1:1).EQ.'-') GOTO 1100
			PRDFAC=LMPPRM(ILMP,IPRM)
			WRITE (CHFAC,'(F8.3)') PRDFAC
			IF (CHFAC.EQ.'   0.000') GOTO 1100
			RXNNC=RXNNC-(PRDNC(I)*PRDFAC)
			GOTO 1102
		ENDIF
 1101	CONTINUE
	GOTO 1100
 1102	CONTINUE
C
	IF (CHFAC.EQ.'   1.000') THEN
		CHPRD=PRDNAM
	ELSE
		IF (CHFAC(3:3).EQ.' ') THEN
			ICHF1=4
		ELSEIF (CHFAC(2:2).EQ.' ') THEN
			ICHF1=3
		ELSEIF (CHFAC(1:1).EQ.' ') THEN
			ICHF1=2
		ELSE
			ICHF1=1
		ENDIF
		IF (CHFAC(5:8).EQ.'.000') THEN
			ICHF2=4
		ELSEIF (CHFAC(7:8).EQ.'00') THEN
			ICHF2=6
		ELSEIF (CHFAC(8:8).EQ.'0') THEN
			ICHF2=7
		ELSE
			ICHF2=8
		ENDIF
		IF (INDRXN.EQ.1) THEN
			CHPRD=" #"//CHFAC(ICHF1:ICHF2)//' '//PRDNAM
		ELSE
			CHPRD=' '//CHFAC(ICHF1:ICHF2)//'*'//PRDNAM
		ENDIF
	ENDIF
	LCHPRD=LNBLNK(CHPRD)
C
C	NEW LINE IF WILL BE >79 WITH " +" AFTER IT
C
	IF (ICHR+LCHPRD.GT.77) THEN
		WRITE (IUNIT,1) OUTLIN(1:ICHR)
		IF (INDRXN.EQ.1) THEN
			OUTLIN='                            '
			ICHR=29
		ELSE
			OUTLIN='       '
			ICHR=7
		ENDIF
	ENDIF
	OUTLIN=OUTLIN(1:ICHR)//CHPRD(1:LCHPRD)//' +'
	ICHR=ICHR+LCHPRD+2
C
 1100	CONTINUE
C
C	END LOOP OVER PRODUCTS.  OUTPUT STRING
C
	IF (OUTLIN(ICHR:ICHR).EQ.'+') ICHR=ICHR-2
	IF (INDRXN.EQ.1) THEN
		WRITE (IUNIT,1) OUTLIN(1:ICHR)
	ELSE
		LKP=LNBLNK(KPCHR)
		IF (ICHR+LKP.GT.77) THEN
			WRITE (IUNIT,1) OUTLIN(1:ICHR)
			WRITE (IUNIT,1) '       '//KPCHR(1:LKP)//';'
		ELSE
			WRITE (IUNIT,1) OUTLIN(1:ICHR)//' '//
     &			 KPCHR(1:LKP)//';'
		ENDIF
	ENDIF
C
C	LOOP BACK TO LOOK FOR PARAMETERS FOR THE NEXT REACTION
C	(IF ANY LEFT)
C
	GOTO 10
	END
	SUBROUTINE RXNEND (IUNIT,INDRXN)
C
C	WRITES ENDING RECORD(S) FOR SPECIFIED TYPE OF MECHANISM, THEN
C	CLOSE FILE
C
	IF (INDRXN.EQ.1) THEN
		WRITE (IUNIT,1) '.'
	ELSE
		WRITE (IUNIT,1) 'END'
	ENDIF
    1	FORMAT (A)
	CLOSE (UNIT=IUNIT)
	RETURN
	END